"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "FederatedTypesStatsPlugin", {
    enumerable: true,
    get: function() {
        return FederatedTypesStatsPlugin;
    }
});
const _interop_require_default = require("@swc/helpers/_/_interop_require_default");
const _webpack = require("webpack");
const _generateTypesStats = require("../lib/generateTypesStats");
const _fs = /*#__PURE__*/ _interop_require_default._(require("fs"));
const _path = /*#__PURE__*/ _interop_require_default._(require("path"));
const PLUGIN_NAME = 'FederatedTypesStatsPlugin';
let FederatedTypesStatsPlugin = class FederatedTypesStatsPlugin {
    apply(compiler) {
        compiler.hooks.afterEmit.tap(PLUGIN_NAME, (compilation)=>{
            const federatedTypesMap = compilation.params.federated_types;
            const { typesIndexJsonFilePath, publicPath } = this.options;
            const statsJson = {
                publicPath,
                files: (0, _generateTypesStats.generateTypesStats)(federatedTypesMap, this.options)
            };
            const source = new _webpack.sources.RawSource(JSON.stringify(statsJson));
            const asset = compilation.getAsset(typesIndexJsonFilePath);
            const dest = _path.default.join(compiler.outputPath, typesIndexJsonFilePath);
            const writeStream = _fs.default.createWriteStream(dest);
            writeStream.write(JSON.stringify(statsJson));
            writeStream.end();
        });
    }
    constructor(options){
        this.options = options;
    }
};

//# sourceMappingURL=FederatedTypesStatsPlugin.js.map